package p09_importowanie;

import static p08_funkcje.Geometria.obwodKola;
import static p08_funkcje.Geometria.obwodKwadratu;
import static p08_funkcje.Geometria.obwodProstokata;
import static p08_funkcje.Geometria.obwodTrojkata;
import static p08_funkcje.Geometria.poleKola;
import static p08_funkcje.Geometria.poleKwadratu;
import static p08_funkcje.Geometria.poleProstokata;
import static p08_funkcje.Geometria.poleTrojkata;
import static p08_funkcje.Geometria.warunekTrojkata;
import static p08_funkcje.JednostkiMiary.c_na_f;
import static p08_funkcje.JednostkiMiary.f_na_c;
import static p08_funkcje.JednostkiMiary.km_na_mile;
import static p08_funkcje.JednostkiMiary.mile_na_km;

import java.util.Locale;
import java.util.Scanner;

/* Gdy w programie korzystamy tylko z elementów statycznych klasy X (z metod statycznych, zmiennych statycznych, stałych),
 * to zamiast importować tę klasę i wywoływać te elementy pisząc X.metoda
 * można zaimportować statycznie tę metodę (albo zmienną, stałą ...).
 *
 * Wtedy w treści programy używamy zaimportowanych rzeczy tak, jakby były zdefiniowane w naszej klasie.
 * (albo tak jakby były funkcjami, tak jak w Pythonie, C++, PHP itp...)
 *
 * Nie ma jak użyć import static w stosunku do klasy Scanner, bo jej używamy w sposób "obiektowy":
 * tworzony jest obiekt klasy Scanner i na nim wywoływana jest metoda (nie jest statyczna).
 */

public class Program4 {

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        Scanner scanner = new Scanner(System.in);
        System.out.println("Dostępne polecenia:");
        System.out.println("  K  - kwadrat");
        System.out.println("  O  - koło");
        System.out.println("  P  - prostokąt");
        System.out.println("  T  - trójkąt");
        System.out.println("  KM - przelicz kilometry na mile");
        System.out.println("  MK - przelicz mile na kilometry");
        System.out.println("  CF - przelicz °C na °F");
        System.out.println("  FC - przelicz °F na °C");
        System.out.println("  Q  - zakończ");
        
        petla:
        while(true) {
            System.out.println("\nWybierz figurę lub operację:");
            
            String wybor = scanner.next().toUpperCase();

            switch(wybor) {
                case "Q" -> {
                    break petla;
                }
                case "K" -> {
                    System.out.print("Podaj długość boku kwadratu: ");
                    double a = scanner.nextDouble();
                    double pole = poleKwadratu(a);
                    double obwod = obwodKwadratu(a);
                    System.out.printf("Dla kwadratu o boku %.3f pole wynosi %.3f, a obwód %.3f\n", a, pole, obwod);
                }
                case "P" -> {
                    System.out.print("Podaj dwie długości boków prostokąta: ");
                    double a = scanner.nextDouble();
                    double b = scanner.nextDouble();
                    double pole = poleProstokata(a, b);
                    double obwod = obwodProstokata(a, b);
                    System.out.printf("Dla prostokąta o bokach %.3f i %.3f pole wynosi %.3f, a obwód %.3f\n", a, b, pole, obwod);
                }
                case "O" -> {
                    System.out.print("Podaj promień koła: ");
                    double r = scanner.nextDouble();
                    double pole = poleKola(r);
                    double obwod = obwodKola(r);
                    System.out.printf("Dla koła o promieniu %.3f pole wynosi %.3f, a obwód %.3f\n", r, pole, obwod);
                }
                case "T" -> {
                    System.out.print("Podaj trzy długości boków trójkąta: ");
                    double a = scanner.nextDouble();
                    double b = scanner.nextDouble();
                    double c = scanner.nextDouble();
                    if(warunekTrojkata(a, b, c)) {
                        double pole = poleTrojkata(a, b, c);
                        double obwod = obwodTrojkata(a, b, c);
                        System.out.printf("Dla prostokąta o bokach %.3f %.3f %.3f pole wynosi %.3f, a obwód %.3f\n", a, b, c, pole, obwod);
                    } else {
                        System.out.println("Z tych liczb nie da się złożyć trójkąta");
                    }
                }
                case "KM" -> {
                    System.out.print("Podaj odległość w kilometrach: ");
                    double km = scanner.nextDouble();
                    double wynik = km_na_mile(km);
                    System.out.printf("%.3f km = %.3f mil\n", km, wynik);
                }
                case "MK" -> {
                    System.out.print("Podaj odległość w milach: ");
                    double mile = scanner.nextDouble();
                    double wynik = mile_na_km(mile);
                    System.out.printf("%.3f mil = %.3f km\n", mile, wynik);
                }
                case "FC" -> {
                    System.out.print("Podaj temperaturę w Fahrenheitach: ");
                    double f = scanner.nextDouble();
                    double wynik = f_na_c(f);
                    System.out.printf("%.3f °F = %.3f °C\n", f, wynik);
                }
                case "CF" -> {
                    System.out.print("Podaj temperaturę w Celsjuszach: ");
                    double c = scanner.nextDouble();
                    double wynik = c_na_f(c);
                    System.out.printf("%.3f °C = %.3f °F\n", c, wynik);
                }
                default -> {
                    System.out.println("Nieznane polecenie " + wybor);
                }
            }
        }
        System.out.println("Dzięki, miłego dnia!");
    }

}