package p11_overloading;

public class BiletUlgowy1 {
    
    private static class Osoba {
        
    }
    
    private static class Student extends Osoba {
        
    }
    
    // Oczekiwana logika: jeśli klientem jest zwykła osoba, to bilet kosztuje 100,
    // a jeśli student, to 50
    static int cenaBiletu(Osoba klient) {
        // instanceof sprawdza W CZASIE DZIAŁANIA, jakiej klasy jest obiekt w pamięci
        if(klient instanceof Student) {
            return 50;
        } else {
            return 100;
        }
    }

    public static void main(String[] args) {
        Osoba o = new Osoba();
        Student s = new Student();
        
        System.out.println("Cena biletu dla osoby: " + cenaBiletu(o));
        System.out.println("Cena biletu dla studenta: " + cenaBiletu(s));
        System.out.println();
        
        Osoba[] osoby = {o, s};
        for (Osoba klient : osoby) {
            System.out.println("Dla obiektu klasy " + klient.getClass().getSimpleName()
                    + " sprzedajemy bilet za cenę " + cenaBiletu(klient));
        }
    }

}
