package p11_overloading;

// Uwaga, to jest złe rozwiązanie!
public class BiletUlgowy2 {
    
    private static class Osoba {
        
    }
    
    private static class Student extends Osoba {
        
    }
    
    // Oczekiwana logika: jeśli klientem jest zwykła osoba, to bilet kosztuje 100,
    // a jeśli student, to 50
    static int cenaBiletu(Osoba klient) {
        return 100;
    }
    
    static int cenaBiletu(Student klient) {
        return 50;
    }

    public static void main(String[] args) {
        Osoba o = new Osoba();
        Student s = new Student();
        
        System.out.println("Cena biletu dla osoby: " + cenaBiletu(o));
        System.out.println("Cena biletu dla studenta: " + cenaBiletu(s));
        System.out.println();
        
        Osoba[] osoby = {o, s};
        for (var klient : osoby) {
            System.out.println("Dla obiektu klasy " + klient.getClass().getSimpleName()
                    + " sprzedajemy bilet za cenę " + cenaBiletu(klient));
        }
        // Overloading jest techniką czasu kompilacji.
        // To kompilator na podstawie ZADEKLAROWANEGO TYPU (zmiennej lub wartości)
        // ustala, której wersji metody użyje. Na ten wybór nie wpływa faktyczna klasa obiektu w pamięci w czasie działania.
        // Tutaj zmienna klient jest typu Osoba, więc w linii 34 ZAWSZE zostanie użyta metoda cenaBiletu(Osoba) (a nie Student)

    }

}
