package p11_overloading;

public class BiletUlgowy3 {
    
    private static class Osoba {
        double znizka() {
            return 0;
        }
    }
    
    private static class Student extends Osoba {
        @Override
        double znizka() {
            return 0.5;
        }
    }
    // technika overriding (nadpisywanie metod) działa w oparciu o faktyczną klase obiektu
    // w czasie działania (runtime)
    
    static int cenaBiletu(Osoba klient) {
        double cenaPodstawowa = 100;
        return (int)(cenaPodstawowa * (1.0 - klient.znizka()));
    }

    public static void main(String[] args) {
        Osoba o = new Osoba();
        Student s = new Student();
        
        System.out.println("Cena biletu dla osoby: " + cenaBiletu(o));
        System.out.println("Cena biletu dla studenta: " + cenaBiletu(s));
        System.out.println();
        
        Osoba[] osoby = {o, s};
        for (var klient : osoby) {
            System.out.println("Dla obiektu klasy " + klient.getClass().getSimpleName()
                    + " sprzedajemy bilet za cenę " + cenaBiletu(klient));
        }
    }

}
