package p11_overloading;

// Czasami nie jest oczywiste, czy to, co robimy w podklasie, to jest override, czy overload.
// O tym jest ten przykład.

// Analogiczny przykład "z życia" - próba definiowania equals w taki sposób,
// że parametr nie jest typu Object, tylko np. typu Osoba.
public class OverloadingVsOverriding {
    
    private static class Nadklasa {
        public void print(Number arg) {
            System.out.println("Nadklasa Number " + arg);
        }
        
        // nie ma metody od Byte
        
        public void print(Integer arg) {
            System.out.println("Nadklasa Integer " + arg);
        }
    }
    
    private static class Podklasa extends Nadklasa {
        public void print(Number arg) {
            System.out.println("Podklasa Number " + arg + " obiekt jest klasy " + arg.getClass().getSimpleName());
        }
        
        public void print(Byte arg) {
            System.out.println("Podklasa Byte " + arg);
        }
    }

    public static void main(String[] args) {
        Integer ii = 7000;
        Byte bb = 5;
        Number n = ii;
        
        Nadklasa nad = new Nadklasa();
        nad.print(ii);
        nad.print(bb);
        System.out.println();
        
        Podklasa pod = new Podklasa();
        pod.print(ii);
        pod.print(bb);
        pod.print(n);
        System.out.println();
        
        Nadklasa zmienna = pod;
        zmienna.print(ii);
        zmienna.print(bb);
        zmienna.print(n);
    }
}
