package p14_lambdy;

public class Przyklady {

    public static void main(String[] args) {
        // Sposoby tworzenia obiektu zgodnego z interfejsem
        // sprzed Javy 8:
        // 1. Oddzielna klasa w projekcie
        MnozeniePrzez10 m10 = new MnozeniePrzez10();
        System.out.println(m10);
        System.out.println(m10.oblicz(11)); // 110
        FunkcjaLiczbowa m10_inaczej = new MnozeniePrzez10();
        System.out.println(m10_inaczej);
        System.out.println(m10_inaczej.oblicz(22)); // 220

        // 2. Klasa anonimowa
        FunkcjaLiczbowa m3 = new FunkcjaLiczbowa() {
            public double oblicz(double x) {
                return 3*x;
            }
        };
        System.out.println(m3);
        System.out.println(m3.oblicz(50)); // 150
        // Istnieją jeszcze klasy wewnętrzne i klasy lokalne, ale to pomijamy...
        System.out.println();

        // Od Java 8 możemy używać wyrażeń lambda oraz referencji do metod
        // wobec interfejsów funkcyjnych, czyli tych, w których do zaimplementowania jest jedna metoda.
        FunkcjaLiczbowa f1 = x -> x*x;
        System.out.println(f1);
        System.out.println(f1.oblicz(5));
        System.out.println(f1.oblicz(6));
        System.out.println(f1.napisz(7));

        FunkcjaLiczbowa f2 = (double arg) -> {
            double zmienna = 10*arg;
            zmienna += 5;
            return zmienna;
        };
        System.out.println(f2);
        System.out.println(f2.oblicz(7));
        System.out.println(f2.oblicz(100));
        System.out.println();

        FunkcjaLiczbowa f3 = Math::sqrt;
        System.out.println(f3);
        System.out.println(f3.oblicz(81));
        System.out.println(f3.oblicz(2));
        System.out.println(f3.napisz(121));
    }

}
