package p20_pliki;

import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.time.LocalTime;

public class ZapiszPlik3 {

    public static void main(String[] args) {
        LocalTime now = LocalTime.now();
        System.out.println(now);
        int cyfra = now.getSecond() % 10;

        // Najczęściej używanym sposobem zapisywania danych do plików tekstowych jest PrintWriter
        // Od Java 7 istnieje konstrukcja "try-with-resources"
        // "Zasoby" otwarte w nazwiasach okrągłych za słowem try
        // są automatycznie zamykane w momencie opuszczania tego bloku try
        // w każdej z sytuacji:
        // - program normalnie dochodzi do końca try
        // - następuje wyjątek i jest on obsłużony w catch
        // - następuje wyjątek i nie jest on obsługiwany
        // - gdy z bloku try wychodzimy za pomocą return, break, continue
        try(PrintWriter out = new PrintWriter("nowy3.txt")) {
            out.println("Ala ma kota");
            out.println("Ola ma psa");
            out.println("czas: " + now);
            out.println("wynik dzielenia: " + (100 / cyfra));
            out.println("Ostatnia linia");
            // wewnątrz try-with-resources nie trzeba już pisać close
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (ArithmeticException e) {
            System.out.println("nie dziel przez zero!");
        }
        System.out.println("Gotowe");
    }

}
